cc9d2d21ef4a5256c202f30756f5cddd9b0871c5
[ganeti-github.git] / Makefile.am
1 # Ganeti makefile
2 # - Indent with tabs only.
3 # - Keep files sorted; one line per file.
4 # - Directories in lib/ must have their own *dir variable (see hypervisor).
5 # - All directories must be listed DIRS.
6 # - Use autogen.sh to generate Makefile.in and configure script.
7
8 # Automake doesn't export these variables before version 1.10.
9 abs_top_builddir = @abs_top_builddir@
10 abs_top_srcdir = @abs_top_srcdir@
11
12 # Helper values for calling builtin functions
13 empty :=
14 space := $(empty) $(empty)
15 comma := ,
16
17 # Helper function to strip src/ and test/hs/ from a list
18 strip_hsroot = $(patsubst src/%,%,$(patsubst test/hs/%,%,$(1)))
19
20 # Use bash in order to be able to use pipefail
21 SHELL=/bin/bash
22
23 ACLOCAL_AMFLAGS = -I autotools
24 BUILD_BASH_COMPLETION = $(top_srcdir)/autotools/build-bash-completion
25 RUN_IN_TEMPDIR = $(top_srcdir)/autotools/run-in-tempdir
26 CHECK_PYTHON_CODE = $(top_srcdir)/autotools/check-python-code
27 CHECK_HEADER = $(top_srcdir)/autotools/check-header
28 CHECK_MAN_DASHES = $(top_srcdir)/autotools/check-man-dashes
29 CHECK_MAN_REFERENCES = $(top_srcdir)/autotools/check-man-references
30 CHECK_MAN_WARNINGS = $(top_srcdir)/autotools/check-man-warnings
31 CHECK_VERSION = $(top_srcdir)/autotools/check-version
32 CHECK_NEWS = $(top_srcdir)/autotools/check-news
33 CHECK_IMPORTS = $(top_srcdir)/autotools/check-imports
34 DOCPP = $(top_srcdir)/autotools/docpp
35 REPLACE_VARS_SED = autotools/replace_vars.sed
36 CONVERT_CONSTANTS = $(top_srcdir)/autotools/convert-constants
37 BUILD_RPC = $(top_srcdir)/autotools/build-rpc
38 SHELL_ENV_INIT = autotools/shell-env-init
39
40 # Note: these are automake-specific variables, and must be named after
41 # the directory + 'dir' suffix
42 clientdir = $(pkgpythondir)/client
43 cmdlibdir = $(pkgpythondir)/cmdlib
44 hypervisordir = $(pkgpythondir)/hypervisor
45 httpdir = $(pkgpythondir)/http
46 masterddir = $(pkgpythondir)/masterd
47 confddir = $(pkgpythondir)/confd
48 rapidir = $(pkgpythondir)/rapi
49 serverdir = $(pkgpythondir)/server
50 watcherdir = $(pkgpythondir)/watcher
51 impexpddir = $(pkgpythondir)/impexpd
52 utilsdir = $(pkgpythondir)/utils
53 toolsdir = $(pkglibdir)/tools
54 iallocatorsdir = $(pkglibdir)/iallocators
55 pytoolsdir = $(pkgpythondir)/tools
56 docdir = $(datadir)/doc/$(PACKAGE)
57 myexeclibdir = $(pkglibdir)
58
59 # Delete output file if an error occurred while building it
60 .DELETE_ON_ERROR:
61
62 HS_DIRS = \
63         src \
64         src/Ganeti \
65         src/Ganeti/Block \
66         src/Ganeti/Block/Drbd \
67         src/Ganeti/Confd \
68         src/Ganeti/Curl \
69         src/Ganeti/DataCollectors \
70         src/Ganeti/HTools \
71         src/Ganeti/HTools/Backend \
72         src/Ganeti/HTools/Program \
73         src/Ganeti/Hypervisor \
74         src/Ganeti/Hypervisor/Xen \
75         src/Ganeti/Monitoring \
76         src/Ganeti/Query \
77         test/hs \
78         test/hs/Test \
79         test/hs/Test/Ganeti \
80         test/hs/Test/Ganeti/Block \
81         test/hs/Test/Ganeti/Block/Drbd \
82         test/hs/Test/Ganeti/Confd \
83         test/hs/Test/Ganeti/HTools \
84         test/hs/Test/Ganeti/HTools/Backend \
85         test/hs/Test/Ganeti/Hypervisor \
86         test/hs/Test/Ganeti/Hypervisor/Xen \
87         test/hs/Test/Ganeti/Query
88
89 # Haskell directories without the roots (src, test/hs)
90 HS_DIRS_NOROOT = $(filter-out src,$(filter-out test/hs,$(HS_DIRS)))
91
92 DIRS = \
93         $(HS_DIRS) \
94         autotools \
95         daemons \
96         devel \
97         devel/data \
98         doc \
99         doc/css \
100         doc/examples \
101         doc/examples/gnt-debug \
102         doc/examples/hooks \
103         test/data/htools \
104         test/data/htools/rapi \
105         test/hs/shelltests \
106         lib \
107         lib/build \
108         lib/client \
109         lib/cmdlib \
110         lib/confd \
111         lib/http \
112         lib/hypervisor \
113         lib/impexpd \
114         lib/masterd \
115         lib/rapi \
116         lib/server \
117         lib/tools \
118         lib/utils \
119         lib/watcher \
120         man \
121         qa \
122         test \
123         test/data \
124         test/data/bdev-rbd \
125         test/data/ovfdata \
126         test/data/ovfdata/other \
127         test/py \
128         tools
129
130 ALL_APIDOC_HS_DIRS = \
131         $(APIDOC_HS_DIR) \
132         $(patsubst %,$(APIDOC_HS_DIR)/%,$(call strip_hsroot,$(HS_DIRS_NOROOT)))
133
134 BUILDTIME_DIR_AUTOCREATE = \
135         scripts \
136         $(APIDOC_DIR) \
137         $(ALL_APIDOC_HS_DIRS) \
138         $(APIDOC_PY_DIR) \
139         $(COVERAGE_DIR) \
140         $(COVERAGE_HS_DIR) \
141         $(COVERAGE_PY_DIR) \
142         .hpc
143
144 BUILDTIME_DIRS = \
145         $(BUILDTIME_DIR_AUTOCREATE) \
146         doc/html \
147         doc/man-html
148
149 DIRCHECK_EXCLUDE = \
150         $(BUILDTIME_DIRS) \
151         ganeti-[0-9]*.[0-9]*.[0-9]* \
152         doc/html/_* \
153         doc/man-html/_* \
154         autom4te.cache
155
156 # some helper vars
157 COVERAGE_DIR = doc/coverage
158 COVERAGE_PY_DIR = $(COVERAGE_DIR)/py
159 COVERAGE_HS_DIR = $(COVERAGE_DIR)/hs
160 APIDOC_DIR = doc/api
161 APIDOC_PY_DIR = $(APIDOC_DIR)/py
162 APIDOC_HS_DIR = $(APIDOC_DIR)/hs
163
164 MAINTAINERCLEANFILES = \
165         $(maninput) \
166         doc/install-quick.rst \
167         doc/news.rst \
168         doc/upgrade.rst \
169         vcs-version
170
171 maintainer-clean-local:
172         rm -rf $(BUILDTIME_DIRS)
173
174 CLEANFILES = \
175         $(addsuffix /*.py[co],$(DIRS)) \
176         $(addsuffix /*.hi,$(HS_DIRS)) \
177         $(addsuffix /*.o,$(HS_DIRS)) \
178         $(PYTHON_BOOTSTRAP) \
179         epydoc.conf \
180         $(REPLACE_VARS_SED) \
181         $(SHELL_ENV_INIT) \
182         daemons/daemon-util \
183         daemons/ganeti-cleaner \
184         devel/squeeze-amd64.tar.gz \
185         devel/squeeze-amd64.conf \
186         $(mandocrst) \
187         doc/manpages-enabled.rst \
188         $(BUILT_EXAMPLES) \
189         doc/examples/bash_completion \
190         doc/examples/bash_completion-debug \
191         lib/_generated_rpc.py \
192         $(man_MANS) \
193         $(manhtml) \
194         tools/kvm-ifup \
195         tools/users-setup \
196         tools/vcluster-setup \
197         stamp-directories \
198         stamp-srclinks \
199         $(nodist_pkgpython_PYTHON) \
200         $(HS_ALL_PROGS) $(HS_BUILT_SRCS) \
201         $(HS_BUILT_TEST_HELPERS) \
202         src/ganeti-confd \
203         src/ganeti-mond \
204         .hpc/*.mix src/*.tix test/hs/*.tix \
205         doc/hs-lint.html
206
207 GENERATED_FILES = \
208         $(built_base_sources) \
209         $(BUILT_PYTHON_SOURCES) \
210         $(PYTHON_BOOTSTRAP)
211
212 HS_GENERATED_FILES =
213 if WANT_HTOOLS
214 HS_GENERATED_FILES += $(HS_PROGS)
215 if ENABLE_CONFD
216 HS_GENERATED_FILES += src/hconfd src/ganeti-confd
217 endif
218
219 if ENABLE_MOND
220 HS_GENERATED_FILES += src/ganeti-mond
221 endif
222 endif
223
224 built_base_sources = \
225         stamp-directories \
226         stamp-srclinks
227
228 built_python_base_sources = \
229         lib/_autoconf.py \
230         lib/_vcsversion.py
231
232 BUILT_PYTHON_SOURCES = \
233         $(built_python_base_sources) \
234         lib/_generated_rpc.py
235
236 # Generating the RPC wrappers depends on many things, so make sure
237 # it's built at the end of the built sources
238 lib/_generated_rpc.py: | $(built_base_sources) $(built_python_base_sources)
239
240 # these are all built from the underlying %.in sources
241 BUILT_EXAMPLES = \
242         doc/examples/ganeti-kvm-poweroff.initd \
243         doc/examples/ganeti.cron \
244         doc/examples/ganeti.initd \
245         doc/examples/ganeti-master-role.ocf \
246         doc/examples/ganeti-node-role.ocf \
247         doc/examples/gnt-config-backup \
248         doc/examples/hooks/ipsec
249
250 nodist_pkgpython_PYTHON = \
251         $(BUILT_PYTHON_SOURCES)
252
253 noinst_PYTHON = \
254         lib/build/__init__.py \
255         lib/build/shell_example_lexer.py \
256         lib/build/sphinx_ext.py
257
258 pkgpython_PYTHON = \
259         lib/__init__.py \
260         lib/asyncnotifier.py \
261         lib/backend.py \
262         lib/bdev.py \
263         lib/bootstrap.py \
264         lib/cli.py \
265         lib/compat.py \
266         lib/config.py \
267         lib/constants.py \
268         lib/daemon.py \
269         lib/errors.py \
270         lib/hooksmaster.py \
271         lib/ht.py \
272         lib/jqueue.py \
273         lib/jstore.py \
274         lib/locking.py \
275         lib/luxi.py \
276         lib/mcpu.py \
277         lib/netutils.py \
278         lib/objects.py \
279         lib/opcodes.py \
280         lib/outils.py \
281         lib/ovf.py \
282         lib/pathutils.py \
283         lib/qlang.py \
284         lib/query.py \
285         lib/rpc.py \
286         lib/rpc_defs.py \
287         lib/runtime.py \
288         lib/serializer.py \
289         lib/ssconf.py \
290         lib/ssh.py \
291         lib/storage.py \
292         lib/uidpool.py \
293         lib/vcluster.py \
294         lib/network.py \
295         lib/workerpool.py
296
297 client_PYTHON = \
298         lib/client/__init__.py \
299         lib/client/gnt_backup.py \
300         lib/client/gnt_cluster.py \
301         lib/client/gnt_debug.py \
302         lib/client/gnt_group.py \
303         lib/client/gnt_instance.py \
304         lib/client/gnt_job.py \
305         lib/client/gnt_node.py \
306         lib/client/gnt_network.py \
307         lib/client/gnt_os.py \
308         lib/client/gnt_storage.py
309
310 cmdlib_PYTHON = \
311         lib/cmdlib/__init__.py \
312         lib/cmdlib/common.py \
313         lib/cmdlib/base.py \
314         lib/cmdlib/cluster.py \
315         lib/cmdlib/group.py \
316         lib/cmdlib/node.py \
317         lib/cmdlib/tags.py \
318         lib/cmdlib/network.py \
319         lib/cmdlib/test.py
320
321 hypervisor_PYTHON = \
322         lib/hypervisor/__init__.py \
323         lib/hypervisor/hv_base.py \
324         lib/hypervisor/hv_chroot.py \
325         lib/hypervisor/hv_fake.py \
326         lib/hypervisor/hv_kvm.py \
327         lib/hypervisor/hv_lxc.py \
328         lib/hypervisor/hv_xen.py
329
330 rapi_PYTHON = \
331         lib/rapi/__init__.py \
332         lib/rapi/baserlib.py \
333         lib/rapi/client.py \
334         lib/rapi/client_utils.py \
335         lib/rapi/connector.py \
336         lib/rapi/rlib2.py \
337         lib/rapi/testutils.py
338
339 http_PYTHON = \
340         lib/http/__init__.py \
341         lib/http/auth.py \
342         lib/http/client.py \
343         lib/http/server.py
344
345 confd_PYTHON = \
346         lib/confd/__init__.py \
347         lib/confd/client.py
348
349 masterd_PYTHON = \
350         lib/masterd/__init__.py \
351         lib/masterd/iallocator.py \
352         lib/masterd/instance.py
353
354 impexpd_PYTHON = \
355         lib/impexpd/__init__.py
356
357 watcher_PYTHON = \
358         lib/watcher/__init__.py \
359         lib/watcher/nodemaint.py \
360         lib/watcher/state.py
361
362 server_PYTHON = \
363         lib/server/__init__.py \
364         lib/server/masterd.py \
365         lib/server/noded.py \
366         lib/server/rapi.py
367
368 pytools_PYTHON = \
369         lib/tools/__init__.py \
370         lib/tools/burnin.py \
371         lib/tools/ensure_dirs.py \
372         lib/tools/node_cleanup.py \
373         lib/tools/node_daemon_setup.py \
374         lib/tools/prepare_node_join.py
375
376 utils_PYTHON = \
377         lib/utils/__init__.py \
378         lib/utils/algo.py \
379         lib/utils/filelock.py \
380         lib/utils/hash.py \
381         lib/utils/io.py \
382         lib/utils/log.py \
383         lib/utils/lvm.py \
384         lib/utils/mlock.py \
385         lib/utils/nodesetup.py \
386         lib/utils/process.py \
387         lib/utils/retry.py \
388         lib/utils/text.py \
389         lib/utils/wrapper.py \
390         lib/utils/x509.py
391
392 docinput = \
393         doc/conf.py \
394         doc/css/style.css \
395         doc/admin.rst \
396         doc/cluster-merge.rst \
397         doc/design-2.0.rst \
398         doc/design-2.1.rst \
399         doc/design-2.2.rst \
400         doc/design-2.3.rst \
401         doc/design-2.4.rst \
402         doc/design-2.5.rst \
403         doc/design-2.6.rst \
404         doc/design-2.7.rst \
405         doc/design-autorepair.rst \
406         doc/design-bulk-create.rst \
407         doc/design-chained-jobs.rst \
408         doc/design-cpu-pinning.rst \
409         doc/design-device-uuid-name.rst \
410         doc/design-draft.rst \
411         doc/design-htools-2.3.rst \
412         doc/design-http-server.rst \
413         doc/design-impexp2.rst \
414         doc/design-lu-generated-jobs.rst \
415         doc/design-linuxha.rst \
416         doc/design-multi-reloc.rst \
417         doc/design-network.rst \
418         doc/design-node-add.rst \
419         doc/design-oob.rst \
420         doc/design-ovf-support.rst \
421         doc/design-opportunistic-locking.rst \
422         doc/design-partitioned.rst \
423         doc/design-query-splitting.rst \
424         doc/design-query2.rst \
425         doc/design-reason-trail.rst \
426         doc/design-resource-model.rst \
427         doc/design-restricted-commands.rst \
428         doc/design-shared-storage.rst \
429         doc/design-monitoring-agent.rst \
430         doc/design-virtual-clusters.rst \
431         doc/design-x509-ca.rst \
432         doc/design-hroller.rst \
433         doc/design-storagetypes.rst \
434         doc/devnotes.rst \
435         doc/glossary.rst \
436         doc/hooks.rst \
437         doc/iallocator.rst \
438         doc/index.rst \
439         doc/install-quick.rst \
440         doc/install.rst \
441         doc/locking.rst \
442         doc/manpages-disabled.rst \
443         doc/move-instance.rst \
444         doc/news.rst \
445         doc/ovfconverter.rst \
446         doc/rapi.rst \
447         doc/security.rst \
448         doc/upgrade.rst \
449         doc/virtual-cluster.rst \
450         doc/walkthrough.rst
451
452 # Generates file names such as "doc/man-gnt-instance.rst"
453 mandocrst = $(addprefix doc/man-,$(notdir $(manrst)))
454
455 # Haskell programs to be installed in $PREFIX/bin
456 HS_BIN_PROGS=src/htools
457
458 # Haskell programs to be installed in the MYEXECLIB dir
459 if ENABLE_MOND
460 HS_MYEXECLIB_PROGS=src/mon-collector
461 else
462 HS_MYEXECLIB_PROGS=
463 endif
464
465 # Haskell programs to be compiled by "make really-all"
466 HS_COMPILE_PROGS= \
467         src/ganeti-mond \
468         src/hconfd \
469         src/rpc-test
470
471 # All Haskell non-test programs to be compiled but not automatically installed
472 HS_PROGS = $(HS_BIN_PROGS) $(HS_MYEXECLIB_PROGS)
473
474 HS_BIN_ROLES = harep hbal hscan hspace hinfo hcheck hroller
475 HS_HTOOLS_PROGS = $(HS_BIN_ROLES) hail
476
477 HS_ALL_PROGS = \
478         $(HS_PROGS) \
479         test/hs/hpc-htools \
480         test/hs/hpc-mon-collector \
481         test/hs/htest \
482         $(HS_COMPILE_PROGS)
483
484 HS_PROG_SRCS = $(patsubst %,%.hs,$(HS_ALL_PROGS))
485 HS_BUILT_TEST_HELPERS = $(HS_BIN_ROLES:%=test/hs/%) test/hs/hail
486
487 HFLAGS = \
488         -O -Wall -Werror -isrc \
489         -fwarn-monomorphism-restriction \
490         -fwarn-tabs \
491         $(GHC_BYVERSION_FLAGS)
492
493 # extra flags that can be overriden on the command line (e.g. -Wwarn, etc.)
494 HEXTRA =
495 # internal extra flags (used for test/hs/htest mainly)
496 HEXTRA_INT =
497 # exclude options for coverage reports
498 HPCEXCL = --exclude Main \
499         --exclude Ganeti.Constants \
500         --exclude Ganeti.HTools.QC \
501         --exclude Ganeti.THH \
502         --exclude Ganeti.Version \
503         --exclude Test.Ganeti.Attoparsec \
504         --exclude Test.Ganeti.TestCommon \
505         --exclude Test.Ganeti.TestHTools \
506         --exclude Test.Ganeti.TestHelper \
507         --exclude Test.Ganeti.TestImports \
508         $(patsubst src.%,--exclude Test.%,$(subst /,.,$(patsubst %.hs,%, $(HS_LIB_SRCS))))
509
510 HS_LIB_SRCS = \
511         src/Ganeti/Block/Drbd/Types.hs \
512         src/Ganeti/Block/Drbd/Parser.hs \
513         src/Ganeti/BasicTypes.hs \
514         src/Ganeti/Common.hs \
515         src/Ganeti/Compat.hs \
516         src/Ganeti/Confd/Client.hs \
517         src/Ganeti/Confd/Server.hs \
518         src/Ganeti/Confd/Types.hs \
519         src/Ganeti/Confd/Utils.hs \
520         src/Ganeti/Config.hs \
521         src/Ganeti/Curl/Multi.hs \
522         src/Ganeti/Daemon.hs \
523         src/Ganeti/DataCollectors/CLI.hs \
524         src/Ganeti/DataCollectors/Drbd.hs \
525         src/Ganeti/DataCollectors/Program.hs \
526         src/Ganeti/DataCollectors/Types.hs \
527         src/Ganeti/Errors.hs \
528         src/Ganeti/HTools/Backend/IAlloc.hs \
529         src/Ganeti/HTools/Backend/Luxi.hs \
530         src/Ganeti/HTools/Backend/Rapi.hs \
531         src/Ganeti/HTools/Backend/Simu.hs \
532         src/Ganeti/HTools/Backend/Text.hs \
533         src/Ganeti/HTools/CLI.hs \
534         src/Ganeti/HTools/Cluster.hs \
535         src/Ganeti/HTools/Container.hs \
536         src/Ganeti/HTools/ExtLoader.hs \
537         src/Ganeti/HTools/Graph.hs \
538         src/Ganeti/HTools/Group.hs \
539         src/Ganeti/HTools/Instance.hs \
540         src/Ganeti/HTools/Loader.hs \
541         src/Ganeti/HTools/Node.hs \
542         src/Ganeti/HTools/PeerMap.hs \
543         src/Ganeti/HTools/Program/Hail.hs \
544         src/Ganeti/HTools/Program/Harep.hs \
545         src/Ganeti/HTools/Program/Hbal.hs \
546         src/Ganeti/HTools/Program/Hcheck.hs \
547         src/Ganeti/HTools/Program/Hinfo.hs \
548         src/Ganeti/HTools/Program/Hscan.hs \
549         src/Ganeti/HTools/Program/Hspace.hs \
550         src/Ganeti/HTools/Program/Hroller.hs \
551         src/Ganeti/HTools/Program/Main.hs \
552         src/Ganeti/HTools/Types.hs \
553         src/Ganeti/Hypervisor/Xen/XmParser.hs \
554         src/Ganeti/Hypervisor/Xen/Types.hs \
555         src/Ganeti/Hash.hs \
556         src/Ganeti/JQueue.hs \
557         src/Ganeti/JSON.hs \
558         src/Ganeti/Jobs.hs \
559         src/Ganeti/Logging.hs \
560         src/Ganeti/Luxi.hs \
561         src/Ganeti/Monitoring/Server.hs \
562         src/Ganeti/Network.hs \
563         src/Ganeti/Objects.hs \
564         src/Ganeti/OpCodes.hs \
565         src/Ganeti/OpParams.hs \
566         src/Ganeti/Path.hs \
567         src/Ganeti/Query/Common.hs \
568         src/Ganeti/Query/Export.hs \
569         src/Ganeti/Query/Filter.hs \
570         src/Ganeti/Query/Group.hs \
571         src/Ganeti/Query/Job.hs \
572         src/Ganeti/Query/Language.hs \
573         src/Ganeti/Query/Network.hs \
574         src/Ganeti/Query/Node.hs \
575         src/Ganeti/Query/Query.hs \
576         src/Ganeti/Query/Server.hs \
577         src/Ganeti/Query/Types.hs \
578         src/Ganeti/Rpc.hs \
579         src/Ganeti/Runtime.hs \
580         src/Ganeti/Ssconf.hs \
581         src/Ganeti/THH.hs \
582         src/Ganeti/Types.hs \
583         src/Ganeti/Utils.hs
584
585 HS_TEST_SRCS = \
586         test/hs/Test/Ganeti/Attoparsec.hs \
587         test/hs/Test/Ganeti/BasicTypes.hs \
588         test/hs/Test/Ganeti/Block/Drbd/Parser.hs \
589         test/hs/Test/Ganeti/Block/Drbd/Types.hs \
590         test/hs/Test/Ganeti/Common.hs \
591         test/hs/Test/Ganeti/Confd/Types.hs \
592         test/hs/Test/Ganeti/Confd/Utils.hs \
593         test/hs/Test/Ganeti/Daemon.hs \
594         test/hs/Test/Ganeti/Errors.hs \
595         test/hs/Test/Ganeti/HTools/Backend/Simu.hs \
596         test/hs/Test/Ganeti/HTools/Backend/Text.hs \
597         test/hs/Test/Ganeti/HTools/CLI.hs \
598         test/hs/Test/Ganeti/HTools/Cluster.hs \
599         test/hs/Test/Ganeti/HTools/Container.hs \
600         test/hs/Test/Ganeti/HTools/Graph.hs \
601         test/hs/Test/Ganeti/HTools/Instance.hs \
602         test/hs/Test/Ganeti/HTools/Loader.hs \
603         test/hs/Test/Ganeti/HTools/Node.hs \
604         test/hs/Test/Ganeti/HTools/PeerMap.hs \
605         test/hs/Test/Ganeti/HTools/Types.hs \
606         test/hs/Test/Ganeti/Hypervisor/Xen/XmParser.hs \
607         test/hs/Test/Ganeti/JSON.hs \
608         test/hs/Test/Ganeti/Jobs.hs \
609         test/hs/Test/Ganeti/JQueue.hs \
610         test/hs/Test/Ganeti/Luxi.hs \
611         test/hs/Test/Ganeti/Network.hs \
612         test/hs/Test/Ganeti/Objects.hs \
613         test/hs/Test/Ganeti/OpCodes.hs \
614         test/hs/Test/Ganeti/Query/Filter.hs \
615         test/hs/Test/Ganeti/Query/Language.hs \
616         test/hs/Test/Ganeti/Query/Network.hs \
617         test/hs/Test/Ganeti/Query/Query.hs \
618         test/hs/Test/Ganeti/Rpc.hs \
619         test/hs/Test/Ganeti/Runtime.hs \
620         test/hs/Test/Ganeti/Ssconf.hs \
621         test/hs/Test/Ganeti/THH.hs \
622         test/hs/Test/Ganeti/TestCommon.hs \
623         test/hs/Test/Ganeti/TestHTools.hs \
624         test/hs/Test/Ganeti/TestHelper.hs \
625         test/hs/Test/Ganeti/Types.hs \
626         test/hs/Test/Ganeti/Utils.hs
627
628 HS_LIBTEST_SRCS = $(HS_LIB_SRCS) $(HS_TEST_SRCS)
629
630 HS_BUILT_SRCS = \
631         test/hs/Test/Ganeti/TestImports.hs \
632         src/Ganeti/Constants.hs \
633         src/Ganeti/Curl/Internal.hs \
634         src/Ganeti/Version.hs
635 HS_BUILT_SRCS_IN = \
636         $(patsubst %,%.in,$(filter-out src/Ganeti/Curl/Internal.hs,$(HS_BUILT_SRCS))) \
637         src/Ganeti/Curl/Internal.hsc
638
639 HS_LIBTESTBUILT_SRCS = $(HS_LIBTEST_SRCS) $(HS_BUILT_SRCS)
640
641 $(RUN_IN_TEMPDIR): | stamp-directories
642
643 doc/html/index.html: ENABLE_MANPAGES =
644 doc/man-html/index.html: ENABLE_MANPAGES = 1
645 doc/man-html/index.html: doc/manpages-enabled.rst $(mandocrst)
646
647 # Note: we use here an order-only prerequisite, as the contents of
648 # _autoconf.py are not actually influencing the html build output: it
649 # has to exist in order for the sphinx module to be loaded
650 # successfully, but we certainly don't want the docs to be rebuilt if
651 # it changes
652 doc/html/index.html doc/man-html/index.html: $(docinput) doc/conf.py \
653         configure.ac $(RUN_IN_TEMPDIR) lib/build/sphinx_ext.py \
654         lib/build/shell_example_lexer.py lib/opcodes.py lib/ht.py \
655         doc/css/style.css lib/rapi/connector.py lib/rapi/rlib2.py \
656         | $(BUILT_PYTHON_SOURCES)
657         @test -n "$(SPHINX)" || \
658             { echo 'sphinx-build' not found during configure; exit 1; }
659 if !MANPAGES_IN_DOC
660         if test -n '$(ENABLE_MANPAGES)'; then \
661           echo 'Man pages in documentation were disabled at configure time' >&2; \
662           exit 1; \
663         fi
664 endif
665 ## Sphinx provides little control over what content should be included. Some
666 ## mechanisms exist, but they all have drawbacks or actual issues. Since we
667 ## build two different versions of the documentation--once without man pages and
668 ## once, if enabled, with them--some control is necessary. xmpp-wrapper provides
669 ## us with this, but requires running in a temporary directory. It moves the
670 ## correct files into place depending on environment variables.
671         dir=$(dir $@) && \
672         @mkdir_p@ $$dir && \
673         PYTHONPATH=. ENABLE_MANPAGES=$(ENABLE_MANPAGES) COPY_DOC=1 \
674         $(RUN_IN_TEMPDIR) autotools/sphinx-wrapper $(SPHINX) -q -W -b html \
675             -d . \
676             -D version="$(VERSION_MAJOR).$(VERSION_MINOR)" \
677             -D release="$(PACKAGE_VERSION)" \
678             -D graphviz_dot="$(DOT)" \
679             -D enable_manpages="$(ENABLE_MANPAGES)" \
680             doc $(CURDIR)/$$dir && \
681         rm -f $$dir/.buildinfo $$dir/objects.inv
682         touch $@
683
684 doc/html: doc/html/index.html
685
686 doc/man-html: doc/man-html/index.html
687
688 doc/install-quick.rst: INSTALL
689 doc/news.rst: NEWS
690 doc/upgrade.rst: UPGRADE
691
692 doc/install-quick.rst doc/news.rst doc/upgrade.rst:
693         set -e; \
694         { echo '.. This file is automatically updated at build time from $<.'; \
695           echo '.. Do not edit.'; \
696           echo; \
697           cat $<; \
698         } > $@
699
700 doc/manpages-enabled.rst: Makefile | $(built_base_sources)
701         { echo '.. This file is automatically generated, do not edit!'; \
702           echo ''; \
703           echo 'Man pages'; \
704           echo '========='; \
705           echo; \
706           echo '.. toctree::'; \
707           echo '   :maxdepth: 1'; \
708           echo; \
709           for i in $(notdir $(mandocrst)); do \
710             echo "   $$i"; \
711           done | LC_ALL=C sort; \
712         } > $@
713
714 doc/man-%.rst: man/%.gen Makefile $(REPLACE_VARS_SED) | $(built_base_sources)
715 if MANPAGES_IN_DOC
716         { echo '.. This file is automatically updated at build time from $<.'; \
717           echo '.. Do not edit.'; \
718           echo; \
719           echo "$*"; \
720           echo '=========================================='; \
721           tail -n +3 $< | sed -f $(REPLACE_VARS_SED); \
722         } > $@
723 else
724         echo 'Man pages in documentation were disabled at configure time' >&2; \
725         exit 1;
726 endif
727
728 # Things to build but not to install (add it to EXTRA_DIST if it should be
729 # distributed)
730 noinst_DATA = \
731         doc/html \
732         $(BUILT_EXAMPLES) \
733         doc/examples/bash_completion \
734         doc/examples/bash_completion-debug \
735         $(manhtml)
736
737 if MANPAGES_IN_DOC
738 noinst_DATA += doc/man-html
739 endif
740
741 gnt_scripts = \
742         scripts/gnt-backup \
743         scripts/gnt-cluster \
744         scripts/gnt-debug \
745         scripts/gnt-group \
746         scripts/gnt-instance \
747         scripts/gnt-job \
748         scripts/gnt-network \
749         scripts/gnt-node \
750         scripts/gnt-os \
751         scripts/gnt-storage
752
753 PYTHON_BOOTSTRAP_SBIN = \
754         daemons/ganeti-masterd \
755         daemons/ganeti-noded \
756         daemons/ganeti-rapi \
757         daemons/ganeti-watcher \
758         $(gnt_scripts)
759
760 PYTHON_BOOTSTRAP = \
761         $(PYTHON_BOOTSTRAP_SBIN) \
762         tools/burnin \
763         tools/ensure-dirs \
764         tools/node-cleanup \
765         tools/node-daemon-setup \
766         tools/prepare-node-join
767
768 qa_scripts = \
769         qa/__init__.py \
770         qa/ganeti-qa.py \
771         qa/qa_cluster.py \
772         qa/qa_config.py \
773         qa/qa_daemon.py \
774         qa/qa_env.py \
775         qa/qa_error.py \
776         qa/qa_group.py \
777         qa/qa_instance.py \
778         qa/qa_job.py \
779         qa/qa_node.py \
780         qa/qa_os.py \
781         qa/qa_rapi.py \
782         qa/qa_tags.py \
783         qa/qa_utils.py
784
785 bin_SCRIPTS =
786 if WANT_HTOOLS
787 bin_SCRIPTS += $(HS_BIN_PROGS)
788 install-exec-hook:
789         @mkdir_p@ $(DESTDIR)$(iallocatorsdir)
790 # FIXME: this is a hardcoded logic, instead of auto-resolving
791         $(LN_S) -f ../../../bin/htools \
792           $(DESTDIR)$(iallocatorsdir)/hail
793         for role in $(HS_BIN_ROLES); do \
794           $(LN_S) -f htools $(DESTDIR)$(bindir)/$$role ; \
795         done
796 endif
797
798 $(HS_ALL_PROGS): %: %.hs $(HS_LIBTESTBUILT_SRCS) Makefile
799         @if [ "$(notdir $@)" = "test" ] && [ "$(HS_NODEV)" ]; then \
800           echo "Error: cannot run unittests without the development" \
801                " libraries (see devnotes.rst)" 1>&2; \
802           exit 1; \
803         fi
804         @rm -f $(notdir $@).tix
805         $(GHC) --make \
806           $(HFLAGS) \
807           $(HS_PARALLEL3) $(HS_REGEX_PCRE) \
808           -osuf $(notdir $@).o -hisuf $(notdir $@).hi \
809           $(HEXTRA) $(HEXTRA_INT) $@
810         @touch "$@"
811
812 # for the test/hs/htest binary, we need to enable profiling/coverage
813 test/hs/htest: HEXTRA_INT=-fhpc -itest/hs
814
815 # we compile the hpc-htools binary with the program coverage
816 test/hs/hpc-htools: HEXTRA_INT=-fhpc
817
818 # we compile the hpc-mon-collector binary with the program coverage
819 test/hs/hpc-mon-collector: HEXTRA_INT=-fhpc
820
821 # test dependency
822 test/hs/offline-tests.sh: test/hs/hpc-htools test/hs/hpc-mon-collector
823
824 # rules for building profiling-enabled versions of the haskell
825 # programs: hs-prof does the full two-step build, whereas
826 # hs-prof-quick does only the final rebuild (hs-prof must have been
827 # run before)
828 .PHONY: hs-prof hs-prof-quick
829 hs-prof:
830         @if [ -z "$(TARGET)" ]; then \
831           echo "You need to define TARGET when running this rule" 1>&2; \
832           exit 1; \
833         fi
834         $(MAKE) $(AM_MAKEFLAGS) clean
835         $(MAKE) $(AM_MAKEFLAGS) $(TARGET) HEXTRA="-osuf o"
836         rm -f $(HS_ALL_PROGS)
837         $(MAKE) $(AM_MAKEFLAGS) hs-prof-quick
838
839 hs-prof-quick:
840         @if [ -z "$(TARGET)" ]; then \
841           echo "You need to define TARGET when running this rule" 1>&2; \
842           exit 1; \
843         fi
844         $(MAKE) $(AM_MAKEFLAGS) $(TARGET) HEXTRA="-osuf prof_o -prof -auto-all"
845
846 dist_sbin_SCRIPTS = \
847         tools/ganeti-listrunner
848
849 nodist_sbin_SCRIPTS = \
850         $(PYTHON_BOOTSTRAP_SBIN) \
851         daemons/ganeti-cleaner
852
853 if ENABLE_CONFD
854 src/ganeti-confd: src/hconfd
855         cp -f $< $@
856
857 nodist_sbin_SCRIPTS += src/ganeti-confd
858 endif
859
860 if ENABLE_MOND
861 nodist_sbin_SCRIPTS += src/ganeti-mond
862 endif
863
864 python_scripts = \
865         tools/cfgshell \
866         tools/cfgupgrade \
867         tools/cfgupgrade12 \
868         tools/cluster-merge \
869         tools/confd-client \
870         tools/fmtjson \
871         tools/lvmstrap \
872         tools/move-instance \
873         tools/ovfconverter \
874         tools/sanitize-config
875
876 dist_tools_SCRIPTS = \
877         $(python_scripts) \
878         tools/burnin \
879         tools/kvm-console-wrapper \
880         tools/master-ip-setup \
881         tools/xen-console-wrapper
882
883 nodist_tools_python_scripts = \
884         tools/node-cleanup
885
886 nodist_tools_SCRIPTS = \
887         $(nodist_tools_python_scripts) \
888         tools/users-setup \
889         tools/vcluster-setup
890
891 pkglib_python_scripts = \
892         daemons/import-export \
893         tools/check-cert-expired
894
895 nodist_pkglib_python_scripts = \
896         tools/ensure-dirs \
897         tools/node-daemon-setup \
898         tools/prepare-node-join
899
900 myexeclib_SCRIPTS = \
901         daemons/daemon-util \
902         tools/kvm-ifup \
903         $(pkglib_python_scripts) \
904         $(HS_MYEXECLIB_PROGS)
905
906 nodist_myexeclib_SCRIPTS = \
907         $(nodist_pkglib_python_scripts)
908
909 EXTRA_DIST = \
910         NEWS \
911         UPGRADE \
912         epydoc.conf.in \
913         pylintrc \
914         autotools/build-bash-completion \
915         autotools/build-rpc \
916         autotools/check-header \
917         autotools/check-imports \
918         autotools/check-man-dashes \
919         autotools/check-man-references \
920         autotools/check-man-warnings \
921         autotools/check-news \
922         autotools/check-python-code \
923         autotools/check-tar \
924         autotools/check-version \
925         autotools/convert-constants \
926         autotools/docpp \
927         autotools/gen-py-coverage \
928         autotools/sphinx-wrapper \
929         autotools/testrunner \
930         autotools/wrong-hardcoded-paths \
931         $(RUN_IN_TEMPDIR) \
932         daemons/daemon-util.in \
933         daemons/ganeti-cleaner.in \
934         $(pkglib_python_scripts) \
935         devel/upload \
936         devel/webserver \
937         tools/kvm-ifup.in \
938         tools/users-setup.in \
939         tools/vcluster-setup.in \
940         $(docinput) \
941         doc/html \
942         $(BUILT_EXAMPLES:%=%.in) \
943         doc/examples/ganeti.default \
944         doc/examples/ganeti.default-debug \
945         doc/examples/hooks/ethers \
946         doc/examples/gnt-debug/README \
947         doc/examples/gnt-debug/delay0.json \
948         doc/examples/gnt-debug/delay50.json \
949         test/py/lockperf.py \
950         test/py/testutils.py \
951         test/py/mocks.py \
952         $(dist_TESTS) \
953         $(TEST_FILES) \
954         man/footer.rst \
955         $(manrst) \
956         $(maninput) \
957         qa/qa-sample.json \
958         $(qa_scripts) \
959         $(HS_LIBTEST_SRCS) $(HS_BUILT_SRCS_IN) \
960         $(HS_PROG_SRCS) \
961         src/lint-hints.hs \
962         test/hs/cli-tests-defs.sh \
963         test/hs/offline-test.sh \
964         .ghci
965
966 man_MANS = \
967         man/ganeti-cleaner.8 \
968         man/ganeti-confd.8 \
969         man/ganeti-listrunner.8 \
970         man/ganeti-masterd.8 \
971         man/ganeti-mond.8 \
972         man/ganeti-noded.8 \
973         man/ganeti-os-interface.7 \
974         man/ganeti-extstorage-interface.7 \
975         man/ganeti-rapi.8 \
976         man/ganeti-watcher.8 \
977         man/ganeti.7 \
978         man/gnt-backup.8 \
979         man/gnt-cluster.8 \
980         man/gnt-debug.8 \
981         man/gnt-group.8 \
982         man/gnt-network.8 \
983         man/gnt-instance.8 \
984         man/gnt-job.8 \
985         man/gnt-node.8 \
986         man/gnt-os.8 \
987         man/gnt-storage.8 \
988         man/hail.1 \
989         man/hbal.1 \
990         man/hcheck.1 \
991         man/hinfo.1 \
992         man/hscan.1 \
993         man/hspace.1 \
994         man/hroller.1 \
995         man/htools.1 \
996         man/mon-collector.7
997
998 # Remove extensions from all filenames in man_MANS
999 mannoext = $(patsubst %.1,%,$(patsubst %.7,%,$(patsubst %.8,%,$(man_MANS))))
1000
1001 manrst = $(patsubst %,%.rst,$(mannoext))
1002 manhtml = $(patsubst %.rst,%.html,$(manrst))
1003 mangen = $(patsubst %.rst,%.gen,$(manrst))
1004 maninput = \
1005         $(patsubst %.1,%.1.in,$(patsubst %.7,%.7.in,$(patsubst %.8,%.8.in,$(man_MANS)))) \
1006         $(patsubst %.html,%.html.in,$(manhtml)) \
1007         $(mangen)
1008
1009 TEST_FILES = \
1010         test/data/htools/clean-nonzero-score.data \
1011         test/data/htools/common-suffix.data \
1012         test/data/htools/empty-cluster.data \
1013         test/data/htools/hail-alloc-drbd.json \
1014         test/data/htools/hail-alloc-invalid-twodisks.json \
1015         test/data/htools/hail-alloc-twodisks.json \
1016         test/data/htools/hail-change-group.json \
1017         test/data/htools/hail-invalid-reloc.json \
1018         test/data/htools/hail-node-evac.json \
1019         test/data/htools/hail-reloc-drbd.json \
1020         test/data/htools/hbal-excl-tags.data \
1021         test/data/htools/hbal-split-insts.data \
1022         test/data/htools/hspace-tiered-dualspec.data \
1023         test/data/htools/hspace-tiered.data \
1024         test/data/htools/invalid-node.data \
1025         test/data/htools/missing-resources.data \
1026         test/data/htools/multiple-master.data \
1027         test/data/htools/n1-failure.data \
1028         test/data/htools/rapi/groups.json \
1029         test/data/htools/rapi/info.json \
1030         test/data/htools/rapi/instances.json \
1031         test/data/htools/rapi/nodes.json \
1032         test/data/htools/unique-reboot-order.data \
1033         test/hs/shelltests/htools-balancing.test \
1034         test/hs/shelltests/htools-basic.test \
1035         test/hs/shelltests/htools-dynutil.test \
1036         test/hs/shelltests/htools-excl.test \
1037         test/hs/shelltests/htools-hail.test \
1038         test/hs/shelltests/htools-hroller.test \
1039         test/hs/shelltests/htools-hspace.test \
1040         test/hs/shelltests/htools-invalid.test \
1041         test/hs/shelltests/htools-multi-group.test \
1042         test/hs/shelltests/htools-no-backend.test \
1043         test/hs/shelltests/htools-rapi.test \
1044         test/hs/shelltests/htools-single-group.test \
1045         test/hs/shelltests/htools-text-backend.test \
1046         test/hs/shelltests/htools-mon-collector.test \
1047         test/data/bdev-drbd-8.0.txt \
1048         test/data/bdev-drbd-8.3.txt \
1049         test/data/bdev-drbd-disk.txt \
1050         test/data/bdev-drbd-net-ip4.txt \
1051         test/data/bdev-drbd-net-ip6.txt \
1052         test/data/bdev-rbd/json_output_empty.txt \
1053         test/data/bdev-rbd/json_output_extra_matches.txt \
1054         test/data/bdev-rbd/json_output_no_matches.txt \
1055         test/data/bdev-rbd/json_output_ok.txt \
1056         test/data/bdev-rbd/plain_output_new_extra_matches.txt \
1057         test/data/bdev-rbd/plain_output_new_no_matches.txt \
1058         test/data/bdev-rbd/plain_output_new_ok.txt \
1059         test/data/bdev-rbd/plain_output_old_empty.txt \
1060         test/data/bdev-rbd/plain_output_old_extra_matches.txt \
1061         test/data/bdev-rbd/plain_output_old_no_matches.txt \
1062         test/data/bdev-rbd/plain_output_old_ok.txt \
1063         test/data/bdev-rbd/output_invalid.txt \
1064         test/data/cert1.pem \
1065         test/data/cert2.pem \
1066         test/data/cluster_config_2.7.json \
1067         test/data/cluster_config_downgraded_2.7.json \
1068         test/data/instance-minor-pairing.txt \
1069         test/data/ip-addr-show-dummy0.txt \
1070         test/data/ip-addr-show-lo-ipv4.txt \
1071         test/data/ip-addr-show-lo-ipv6.txt \
1072         test/data/ip-addr-show-lo-oneline-ipv4.txt \
1073         test/data/ip-addr-show-lo-oneline-ipv6.txt \
1074         test/data/ip-addr-show-lo-oneline.txt \
1075         test/data/ip-addr-show-lo.txt \
1076         test/data/kvm_0.12.5_help.txt \
1077         test/data/kvm_0.15.90_help.txt \
1078         test/data/kvm_0.9.1_help.txt \
1079         test/data/kvm_0.9.1_help_boot_test.txt \
1080         test/data/kvm_1.0_help.txt \
1081         test/data/kvm_1.1.2_help.txt \
1082         test/data/ovfdata/compr_disk.vmdk.gz \
1083         test/data/ovfdata/config.ini \
1084         test/data/ovfdata/corrupted_resources.ovf \
1085         test/data/ovfdata/empty.ini \
1086         test/data/ovfdata/empty.ovf \
1087         test/data/ovfdata/ganeti.mf \
1088         test/data/ovfdata/ganeti.ovf \
1089         test/data/ovfdata/gzip_disk.ovf \
1090         test/data/ovfdata/new_disk.vmdk \
1091         test/data/ovfdata/no_disk.ini \
1092         test/data/ovfdata/no_disk_in_ref.ovf \
1093         test/data/ovfdata/no_os.ini \
1094         test/data/ovfdata/no_ovf.ova \
1095         test/data/ovfdata/other/rawdisk.raw \
1096         test/data/ovfdata/ova.ova \
1097         test/data/ovfdata/rawdisk.raw \
1098         test/data/ovfdata/second_disk.vmdk \
1099         test/data/ovfdata/unsafe_path.ini \
1100         test/data/ovfdata/virtualbox.ovf \
1101         test/data/ovfdata/wrong_config.ini \
1102         test/data/ovfdata/wrong_extension.ovd \
1103         test/data/ovfdata/wrong_manifest.mf \
1104         test/data/ovfdata/wrong_manifest.ovf \
1105         test/data/ovfdata/wrong_ova.ova \
1106         test/data/ovfdata/wrong_xml.ovf \
1107         test/data/proc_drbd8.txt \
1108         test/data/proc_drbd80-emptyline.txt \
1109         test/data/proc_drbd83.txt \
1110         test/data/proc_drbd83_sync.txt \
1111         test/data/proc_drbd83_sync_want.txt \
1112         test/data/proc_drbd83_sync_krnl2.6.39.txt \
1113         test/data/qa-minimal-nodes-instances-only.json \
1114         test/data/sys_drbd_usermode_helper.txt \
1115         test/data/vgreduce-removemissing-2.02.02.txt \
1116         test/data/vgreduce-removemissing-2.02.66-fail.txt \
1117         test/data/vgreduce-removemissing-2.02.66-ok.txt \
1118         test/data/vgs-missing-pvs-2.02.02.txt \
1119         test/data/vgs-missing-pvs-2.02.66.txt \
1120         test/data/xen-xm-info-4.0.1.txt \
1121         test/data/xen-xm-list-4.0.1-dom0-only.txt \
1122         test/data/xen-xm-list-4.0.1-four-instances.txt \
1123         test/data/xen-xm-list-long-4.0.1.txt \
1124         test/data/xen-xm-uptime-4.0.1.txt \
1125         test/py/ganeti-cli.test \
1126         test/py/gnt-cli.test \
1127         test/py/import-export_unittest-helper
1128
1129 python_tests = \
1130         doc/examples/rapi_testutils.py \
1131         test/py/cfgupgrade_unittest.py \
1132         test/py/docs_unittest.py \
1133         test/py/ganeti.asyncnotifier_unittest.py \
1134         test/py/ganeti.backend_unittest-runasroot.py \
1135         test/py/ganeti.backend_unittest.py \
1136         test/py/ganeti.bdev_unittest.py \
1137         test/py/ganeti.cli_unittest.py \
1138         test/py/ganeti.client.gnt_cluster_unittest.py \
1139         test/py/ganeti.client.gnt_instance_unittest.py \
1140         test/py/ganeti.client.gnt_job_unittest.py \
1141         test/py/ganeti.cmdlib_unittest.py \
1142         test/py/ganeti.compat_unittest.py \
1143         test/py/ganeti.confd.client_unittest.py \
1144         test/py/ganeti.config_unittest.py \
1145         test/py/ganeti.constants_unittest.py \
1146         test/py/ganeti.daemon_unittest.py \
1147         test/py/ganeti.errors_unittest.py \
1148         test/py/ganeti.hooks_unittest.py \
1149         test/py/ganeti.ht_unittest.py \
1150         test/py/ganeti.http_unittest.py \
1151         test/py/ganeti.hypervisor.hv_chroot_unittest.py \
1152         test/py/ganeti.hypervisor.hv_fake_unittest.py \
1153         test/py/ganeti.hypervisor.hv_kvm_unittest.py \
1154         test/py/ganeti.hypervisor.hv_lxc_unittest.py \
1155         test/py/ganeti.hypervisor.hv_xen_unittest.py \
1156         test/py/ganeti.hypervisor_unittest.py \
1157         test/py/ganeti.impexpd_unittest.py \
1158         test/py/ganeti.jqueue_unittest.py \
1159         test/py/ganeti.jstore_unittest.py \
1160         test/py/ganeti.locking_unittest.py \
1161         test/py/ganeti.luxi_unittest.py \
1162         test/py/ganeti.masterd.iallocator_unittest.py \
1163         test/py/ganeti.masterd.instance_unittest.py \
1164         test/py/ganeti.mcpu_unittest.py \
1165         test/py/ganeti.netutils_unittest.py \
1166         test/py/ganeti.objects_unittest.py \
1167         test/py/ganeti.opcodes_unittest.py \
1168         test/py/ganeti.outils_unittest.py \
1169         test/py/ganeti.ovf_unittest.py \
1170         test/py/ganeti.qlang_unittest.py \
1171         test/py/ganeti.query_unittest.py \
1172         test/py/ganeti.rapi.baserlib_unittest.py \
1173         test/py/ganeti.rapi.client_unittest.py \
1174         test/py/ganeti.rapi.resources_unittest.py \
1175         test/py/ganeti.rapi.rlib2_unittest.py \
1176         test/py/ganeti.rapi.testutils_unittest.py \
1177         test/py/ganeti.rpc_unittest.py \
1178         test/py/ganeti.runtime_unittest.py \
1179         test/py/ganeti.serializer_unittest.py \
1180         test/py/ganeti.server.rapi_unittest.py \
1181         test/py/ganeti.ssconf_unittest.py \
1182         test/py/ganeti.ssh_unittest.py \
1183         test/py/ganeti.storage_unittest.py \
1184         test/py/ganeti.tools.burnin_unittest.py \
1185         test/py/ganeti.tools.ensure_dirs_unittest.py \
1186         test/py/ganeti.tools.node_daemon_setup_unittest.py \
1187         test/py/ganeti.tools.prepare_node_join_unittest.py \
1188         test/py/ganeti.uidpool_unittest.py \
1189         test/py/ganeti.utils.algo_unittest.py \
1190         test/py/ganeti.utils.filelock_unittest.py \
1191         test/py/ganeti.utils.hash_unittest.py \
1192         test/py/ganeti.utils.io_unittest-runasroot.py \
1193         test/py/ganeti.utils.io_unittest.py \
1194         test/py/ganeti.utils.log_unittest.py \
1195         test/py/ganeti.utils.lvm_unittest.py \
1196         test/py/ganeti.utils.mlock_unittest.py \
1197         test/py/ganeti.utils.nodesetup_unittest.py \
1198         test/py/ganeti.utils.process_unittest.py \
1199         test/py/ganeti.utils.retry_unittest.py \
1200         test/py/ganeti.utils.text_unittest.py \
1201         test/py/ganeti.utils.wrapper_unittest.py \
1202         test/py/ganeti.utils.x509_unittest.py \
1203         test/py/ganeti.utils_unittest.py \
1204         test/py/ganeti.vcluster_unittest.py \
1205         test/py/ganeti.workerpool_unittest.py \
1206         test/py/pycurl_reset_unittest.py \
1207         test/py/qa.qa_config_unittest.py \
1208         test/py/tempfile_fork_unittest.py
1209
1210 haskell_tests = test/hs/htest
1211
1212 dist_TESTS = \
1213         test/py/check-cert-expired_unittest.bash \
1214         test/py/daemon-util_unittest.bash \
1215         test/py/ganeti-cleaner_unittest.bash \
1216         test/py/import-export_unittest.bash \
1217         test/py/cli-test.bash \
1218         test/py/bash_completion.bash \
1219         $(python_tests)
1220
1221 nodist_TESTS =
1222 check_SCRIPTS =
1223
1224 if WANT_HSTESTS
1225 nodist_TESTS += $(haskell_tests)
1226 dist_TESTS += test/hs/offline-test.sh
1227 check_SCRIPTS += \
1228         test/hs/hpc-htools \
1229         test/hs/hpc-mon-collector \
1230         $(HS_BUILT_TEST_HELPERS)
1231 endif
1232
1233 TESTS = $(dist_TESTS) $(nodist_TESTS)
1234
1235 # Environment for all tests
1236 PLAIN_TESTS_ENVIRONMENT = \
1237         PYTHONPATH=. \
1238         TOP_SRCDIR=$(abs_top_srcdir) TOP_BUILDDIR=$(abs_top_builddir) \
1239         PYTHON=$(PYTHON) FAKEROOT=$(FAKEROOT_PATH) \
1240         $(RUN_IN_TEMPDIR)
1241
1242 # Environment for tests run by automake
1243 TESTS_ENVIRONMENT = \
1244         $(PLAIN_TESTS_ENVIRONMENT) $(abs_top_srcdir)/autotools/testrunner
1245
1246 all_python_code = \
1247         $(dist_sbin_SCRIPTS) \
1248         $(python_scripts) \
1249         $(pkglib_python_scripts) \
1250         $(nodist_pkglib_python_scripts) \
1251         $(nodist_tools_python_scripts) \
1252         $(python_tests) \
1253         $(pkgpython_PYTHON) \
1254         $(client_PYTHON) \
1255         $(cmdlib_PYTHON) \
1256         $(hypervisor_PYTHON) \
1257         $(rapi_PYTHON) \
1258         $(server_PYTHON) \
1259         $(pytools_PYTHON) \
1260         $(http_PYTHON) \
1261         $(confd_PYTHON) \
1262         $(masterd_PYTHON) \
1263         $(impexpd_PYTHON) \
1264         $(utils_PYTHON) \
1265         $(watcher_PYTHON) \
1266         $(noinst_PYTHON) \
1267         $(qa_scripts)
1268
1269 srclink_files = \
1270         man/footer.rst \
1271         test/py/check-cert-expired_unittest.bash \
1272         test/py/daemon-util_unittest.bash \
1273         test/py/ganeti-cleaner_unittest.bash \
1274         test/py/import-export_unittest.bash \
1275         test/py/cli-test.bash \
1276         test/py/bash_completion.bash \
1277         test/hs/offline-test.sh \
1278         test/hs/cli-tests-defs.sh \
1279         $(all_python_code) \
1280         $(HS_LIBTEST_SRCS) $(HS_PROG_SRCS) \
1281         $(docinput)
1282
1283 check_python_code = \
1284         $(BUILD_BASH_COMPLETION) \
1285         $(CHECK_IMPORTS) \
1286         $(CHECK_HEADER) \
1287         $(DOCPP) \
1288         $(all_python_code)
1289
1290 lint_python_code = \
1291         ganeti \
1292         ganeti/http/server.py \
1293         $(dist_sbin_SCRIPTS) \
1294         $(python_scripts) \
1295         $(pkglib_python_scripts) \
1296         $(BUILD_BASH_COMPLETION) \
1297         $(CHECK_IMPORTS) \
1298         $(CHECK_HEADER) \
1299         $(DOCPP) \
1300         $(PYTHON_BOOTSTRAP)
1301
1302 standalone_python_modules = \
1303         lib/rapi/client.py \
1304         tools/ganeti-listrunner
1305
1306 pep8_python_code = \
1307         ganeti \
1308         ganeti/http/server.py \
1309         $(dist_sbin_SCRIPTS) \
1310         $(python_scripts) \
1311         $(pkglib_python_scripts) \
1312         $(BUILD_BASH_COMPLETION) \
1313         $(CHECK_HEADER) \
1314         $(DOCPP) \
1315         $(PYTHON_BOOTSTRAP) \
1316         qa
1317
1318 test/py/daemon-util_unittest.bash: daemons/daemon-util
1319
1320 test/py/ganeti-cleaner_unittest.bash: daemons/ganeti-cleaner
1321
1322 test/py/bash_completion.bash: doc/examples/bash_completion-debug
1323
1324 tools/kvm-ifup: tools/kvm-ifup.in $(REPLACE_VARS_SED)
1325         sed -f $(REPLACE_VARS_SED) < $< > $@
1326         chmod +x $@
1327
1328 tools/users-setup: tools/users-setup.in $(REPLACE_VARS_SED)
1329         sed -f $(REPLACE_VARS_SED) < $< > $@
1330         chmod +x $@
1331
1332 tools/vcluster-setup: tools/vcluster-setup.in $(REPLACE_VARS_SED)
1333         sed -f $(REPLACE_VARS_SED) < $< > $@
1334         chmod +x $@
1335
1336 daemons/%:: daemons/%.in $(REPLACE_VARS_SED)
1337         sed -f $(REPLACE_VARS_SED) < $< > $@
1338         chmod +x $@
1339
1340 doc/examples/%:: doc/examples/%.in $(REPLACE_VARS_SED)
1341         sed -f $(REPLACE_VARS_SED) < $< > $@
1342
1343 doc/examples/bash_completion: BC_ARGS = --compact
1344 doc/examples/bash_completion-debug: BC_ARGS =
1345
1346 doc/examples/bash_completion doc/examples/bash_completion-debug: \
1347         $(BUILD_BASH_COMPLETION) $(RUN_IN_TEMPDIR) \
1348         lib/cli.py $(gnt_scripts) $(client_PYTHON) tools/burnin \
1349         daemons/ganeti-cleaner \
1350         $(GENERATED_FILES) $(HS_GENERATED_FILES)
1351         PYTHONPATH=. $(RUN_IN_TEMPDIR) \
1352           $(CURDIR)/$(BUILD_BASH_COMPLETION) $(BC_ARGS) > $@
1353
1354 man/%.gen: man/%.rst lib/query.py lib/build/sphinx_ext.py \
1355         lib/build/shell_example_lexer.py \
1356         | $(RUN_IN_TEMPDIR) $(BUILT_PYTHON_SOURCES)
1357         @echo "Checking $< for hardcoded paths..."
1358         @if grep -nEf autotools/wrong-hardcoded-paths $<; then \
1359           echo "Man page $< has hardcoded paths (see above)!" 1>&2 ; \
1360           exit 1; \
1361         fi
1362         set -e ; \
1363         trap 'echo auto-removing $@; rm $@' EXIT; \
1364         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(DOCPP) < $< > $@ ;\
1365         $(CHECK_MAN_REFERENCES) $@; \
1366         trap - EXIT
1367
1368 man/%.7.in man/%.8.in man/%.1.in: man/%.gen man/footer.rst
1369         @test -n "$(PANDOC)" || \
1370           { echo 'pandoc' not found during configure; exit 1; }
1371         set -o pipefail -e; \
1372         trap 'echo auto-removing $@; rm $@' EXIT; \
1373         $(PANDOC) -s -f rst -t man $< man/footer.rst | \
1374           sed -e 's/\\@/@/g' > $@; \
1375         if test -n "$(MAN_HAS_WARNINGS)"; then $(CHECK_MAN_WARNINGS) $@; fi; \
1376         $(CHECK_MAN_DASHES) $@; \
1377         trap - EXIT
1378
1379 man/%.html.in: man/%.gen man/footer.rst
1380         @test -n "$(PANDOC)" || \
1381           { echo 'pandoc' not found during configure; exit 1; }
1382         set -o pipefail ; \
1383         $(PANDOC) --toc -s -f rst -t html $< man/footer.rst | \
1384           sed -e 's/\\@/@/g' > $@
1385
1386 man/%: man/%.in  $(REPLACE_VARS_SED)
1387         sed -f $(REPLACE_VARS_SED) < $< > $@
1388
1389 epydoc.conf: epydoc.conf.in $(REPLACE_VARS_SED)
1390         sed -f $(REPLACE_VARS_SED) < $< > $@
1391
1392 vcs-version:
1393         if test -d .git; then \
1394           git describe > $@; \
1395         elif test ! -f $@ ; then \
1396           echo "Cannot auto-generate $@ file"; exit 1; \
1397         fi
1398
1399 .PHONY: clean-vcs-version
1400 clean-vcs-version:
1401         rm -f vcs-version
1402
1403 .PHONY: regen-vcs-version
1404 regen-vcs-version:
1405         @set -e; \
1406         cd $(srcdir); \
1407         if test -d .git; then \
1408           T=`mktemp` ; trap 'rm -f $$T' EXIT; \
1409           git describe > $$T; \
1410           if ! cmp --quiet $$T vcs-version; then \
1411             mv $$T vcs-version; \
1412           fi; \
1413         fi
1414
1415 src/Ganeti/Version.hs: src/Ganeti/Version.hs.in \
1416         vcs-version $(built_base_sources)
1417         set -e; \
1418         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
1419         sed -e "s/%ver%/$$VCSVER/" < $< > $@
1420
1421 src/Ganeti/Constants.hs: src/Ganeti/Constants.hs.in \
1422         lib/constants.py lib/_autoconf.py lib/luxi.py lib/errors.py \
1423         lib/jstore.py $(RUN_IN_TEMPDIR) \
1424         $(CONVERT_CONSTANTS) $(built_base_sources) \
1425         | lib/_vcsversion.py
1426         set -e; \
1427         { cat $< ; \
1428           PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(CONVERT_CONSTANTS); \
1429         } > $@
1430
1431 src/Ganeti/Curl/Internal.hs: src/Ganeti/Curl/Internal.hsc | stamp-directories
1432         hsc2hs -o $@ $<
1433
1434 test/hs/Test/Ganeti/TestImports.hs: test/hs/Test/Ganeti/TestImports.hs.in \
1435         $(built_base_sources)
1436         set -e; \
1437         { cat $< ; \
1438           echo ; \
1439           for name in $(filter-out Ganeti.THH,$(subst /,.,$(patsubst %.hs,%,$(patsubst src/%,%,$(HS_LIB_SRCS))))) ; do \
1440             echo "import $$name ()" ; \
1441           done ; \
1442         } > $@
1443
1444 lib/_autoconf.py: Makefile | stamp-directories
1445         set -e; \
1446         { echo '# This file is automatically generated, do not edit!'; \
1447           echo '#'; \
1448           echo ''; \
1449           echo '"""Build-time configuration for Ganeti.'; \
1450           echo '';\
1451           echo 'This file is autogenerated by the build process.'; \
1452           echo 'For any changes you need to re-run ./configure (and'; \
1453           echo 'not edit by hand).'; \
1454           echo ''; \
1455           echo '"""'; \
1456           echo ''; \
1457           echo '# pylint: disable=C0301,C0324'; \
1458           echo '# because this is autogenerated, we do not want'; \
1459           echo '# style warnings' ; \
1460           echo ''; \
1461           echo "PACKAGE_VERSION = '$(PACKAGE_VERSION)'"; \
1462           echo "VERSION_MAJOR = '$(VERSION_MAJOR)'"; \
1463           echo "VERSION_MINOR = '$(VERSION_MINOR)'"; \
1464           echo "VERSION_REVISION = '$(VERSION_REVISION)'"; \
1465           echo "VERSION_SUFFIX = '$(VERSION_SUFFIX)'"; \
1466           echo "VERSION_FULL = '$(VERSION_FULL)'"; \
1467           echo "LOCALSTATEDIR = '$(localstatedir)'"; \
1468           echo "SYSCONFDIR = '$(sysconfdir)'"; \
1469           echo "SSH_CONFIG_DIR = '$(SSH_CONFIG_DIR)'"; \
1470           echo "SSH_LOGIN_USER = '$(SSH_LOGIN_USER)'"; \
1471           echo "SSH_CONSOLE_USER = '$(SSH_CONSOLE_USER)'"; \
1472           echo "EXPORT_DIR = '$(EXPORT_DIR)'"; \
1473           echo "OS_SEARCH_PATH = [$(OS_SEARCH_PATH)]"; \
1474           echo "ES_SEARCH_PATH = [$(ES_SEARCH_PATH)]"; \
1475           echo "XEN_BOOTLOADER = '$(XEN_BOOTLOADER)'"; \
1476           echo "XEN_CONFIG_DIR = '$(XEN_CONFIG_DIR)'"; \
1477           echo "XEN_KERNEL = '$(XEN_KERNEL)'"; \
1478           echo "XEN_INITRD = '$(XEN_INITRD)'"; \
1479           echo "KVM_KERNEL = '$(KVM_KERNEL)'"; \
1480           echo "FILE_STORAGE_DIR = '$(FILE_STORAGE_DIR)'"; \
1481           echo "ENABLE_FILE_STORAGE = $(ENABLE_FILE_STORAGE)"; \
1482           echo "SHARED_FILE_STORAGE_DIR = '$(SHARED_FILE_STORAGE_DIR)'"; \
1483           echo "ENABLE_SHARED_FILE_STORAGE = $(ENABLE_SHARED_FILE_STORAGE)"; \
1484           echo "IALLOCATOR_SEARCH_PATH = [$(IALLOCATOR_SEARCH_PATH)]"; \
1485           echo "KVM_PATH = '$(KVM_PATH)'"; \
1486           echo "IP_PATH = '$(IP_PATH)'"; \
1487           echo "SOCAT_PATH = '$(SOCAT)'"; \
1488           echo "SOCAT_USE_ESCAPE = $(SOCAT_USE_ESCAPE)"; \
1489           echo "SOCAT_USE_COMPRESS = $(SOCAT_USE_COMPRESS)"; \
1490           echo "LVM_STRIPECOUNT = $(LVM_STRIPECOUNT)"; \
1491           echo "TOOLSDIR = '$(toolsdir)'"; \
1492           echo "GNT_SCRIPTS = [$(foreach i,$(notdir $(gnt_scripts)),'$(i)',)]"; \
1493           echo "HTOOLS_PROGS = [$(foreach i,$(HS_HTOOLS_PROGS),'$(i)',)]"; \
1494           echo "PKGLIBDIR = '$(pkglibdir)'"; \
1495           echo "DRBD_BARRIERS = '$(DRBD_BARRIERS)'"; \
1496           echo "DRBD_NO_META_FLUSH = $(DRBD_NO_META_FLUSH)"; \
1497           echo "SYSLOG_USAGE = '$(SYSLOG_USAGE)'"; \
1498           echo "DAEMONS_GROUP = '$(DAEMONS_GROUP)'"; \
1499           echo "ADMIN_GROUP = '$(ADMIN_GROUP)'"; \
1500           echo "MASTERD_USER = '$(MASTERD_USER)'"; \
1501           echo "MASTERD_GROUP = '$(MASTERD_GROUP)'"; \
1502           echo "RAPI_USER = '$(RAPI_USER)'"; \
1503           echo "RAPI_GROUP = '$(RAPI_GROUP)'"; \
1504           echo "CONFD_USER = '$(CONFD_USER)'"; \
1505           echo "CONFD_GROUP = '$(CONFD_GROUP)'"; \
1506           echo "NODED_USER = '$(NODED_USER)'"; \
1507           echo "NODED_GROUP = '$(NODED_GROUP)'"; \
1508           echo "MOND_USER = '$(MOND_USER)'"; \
1509           echo "MOND_GROUP = '$(MOND_GROUP)'"; \
1510           echo "DISK_SEPARATOR = '$(DISK_SEPARATOR)'"; \
1511           echo "QEMUIMG_PATH = '$(QEMUIMG_PATH)'"; \
1512           echo "HTOOLS = True"; \
1513           echo "ENABLE_CONFD = $(ENABLE_CONFD)"; \
1514           echo "XEN_CMD = '$(XEN_CMD)'"; \
1515           echo "ENABLE_SPLIT_QUERY = $(ENABLE_SPLIT_QUERY)"; \
1516           echo "ENABLE_RESTRICTED_COMMANDS = $(ENABLE_RESTRICTED_COMMANDS)"; \
1517           echo "ENABLE_MOND = $(ENABLE_MOND)"; \
1518 ## Write dictionary with man page name as the key and the section number as the
1519 ## value
1520           echo "MAN_PAGES = {"; \
1521           for i in $(notdir $(man_MANS)); do \
1522             echo "$$i" | sed -re 's/^(.*)\.([0-9]+)$$/  "\1": \2,/g'; \
1523           done; \
1524           echo "}"; \
1525         } > $@
1526
1527 lib/_vcsversion.py: Makefile vcs-version | stamp-directories
1528         set -e; \
1529         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
1530         { echo '# This file is automatically generated, do not edit!'; \
1531           echo '#'; \
1532           echo ''; \
1533           echo '"""Build-time VCS version number for Ganeti.'; \
1534           echo '';\
1535           echo 'This file is autogenerated by the build process.'; \
1536           echo 'For any changes you need to re-run ./configure (and'; \
1537           echo 'not edit by hand).'; \
1538           echo ''; \
1539           echo '"""'; \
1540           echo ''; \
1541           echo '# pylint: disable=C0301,C0324'; \
1542           echo '# because this is autogenerated, we do not want'; \
1543           echo '# style warnings' ; \
1544           echo ''; \
1545           echo "VCS_VERSION = '$$VCSVER'"; \
1546         } > $@
1547
1548 lib/_generated_rpc.py: lib/rpc_defs.py $(BUILD_RPC)
1549         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(BUILD_RPC) lib/rpc_defs.py > $@
1550
1551 $(SHELL_ENV_INIT): Makefile stamp-directories
1552         set -e; \
1553         { echo '# Allow overriding for tests'; \
1554           echo 'readonly LOCALSTATEDIR=$${LOCALSTATEDIR:-$${GANETI_ROOTDIR:-}$(localstatedir)}'; \
1555           echo 'readonly SYSCONFDIR=$${SYSCONFDIR:-$${GANETI_ROOTDIR:-}$(sysconfdir)}'; \
1556           echo; \
1557           echo 'readonly PKGLIBDIR=$(pkglibdir)'; \
1558           echo 'readonly LOG_DIR="$$LOCALSTATEDIR/log/ganeti"'; \
1559           echo 'readonly RUN_DIR="$$LOCALSTATEDIR/run/ganeti"'; \
1560           echo 'readonly DATA_DIR="$$LOCALSTATEDIR/lib/ganeti"'; \
1561           echo 'readonly CONF_DIR="$$SYSCONFDIR/ganeti"'; \
1562         } > $@
1563
1564 ## Writes sed script to replace placeholders with build-time values. The
1565 ## additional quotes after the first @ sign are necessary to stop configure
1566 ## from replacing those values as well.
1567 $(REPLACE_VARS_SED): $(SHELL_ENV_INIT) Makefile stamp-directories
1568         set -e; \
1569         { echo 's#@''PREFIX@#$(prefix)#g'; \
1570           echo 's#@''SYSCONFDIR@#$(sysconfdir)#g'; \
1571           echo 's#@''LOCALSTATEDIR@#$(localstatedir)#g'; \
1572           echo 's#@''BINDIR@#$(bindir)#g'; \
1573           echo 's#@''SBINDIR@#$(sbindir)#g'; \
1574           echo 's#@''LIBDIR@#$(libdir)#g'; \
1575           echo 's#@''GANETI_VERSION@#$(PACKAGE_VERSION)#g'; \
1576           echo 's#@''CUSTOM_XEN_BOOTLOADER@#$(XEN_BOOTLOADER)#g'; \
1577           echo 's#@''CUSTOM_XEN_KERNEL@#$(XEN_KERNEL)#g'; \
1578           echo 's#@''CUSTOM_XEN_INITRD@#$(XEN_INITRD)#g'; \
1579           echo 's#@''CUSTOM_IALLOCATOR_SEARCH_PATH@#$(IALLOCATOR_SEARCH_PATH)#g'; \
1580           echo 's#@''CUSTOM_EXPORT_DIR@#$(EXPORT_DIR)#g'; \
1581           echo 's#@''RPL_FILE_STORAGE_DIR@#$(FILE_STORAGE_DIR)#g'; \
1582           echo 's#@''RPL_SSH_INITD_SCRIPT@#$(SSH_INITD_SCRIPT)#g'; \
1583           echo 's#@''PKGLIBDIR@#$(pkglibdir)#g'; \
1584           echo 's#@''GNTMASTERUSER@#$(MASTERD_USER)#g'; \
1585           echo 's#@''GNTRAPIUSER@#$(RAPI_USER)#g'; \
1586           echo 's#@''GNTCONFDUSER@#$(CONFD_USER)#g'; \
1587           echo 's#@''GNTNODEDUSER@#$(NODED_USER)#g'; \
1588           echo 's#@''GNTMONDUSER@#$(MOND_USER)#g'; \
1589           echo 's#@''GNTRAPIGROUP@#$(RAPI_GROUP)#g'; \
1590           echo 's#@''GNTADMINGROUP@#$(ADMIN_GROUP)#g'; \
1591           echo 's#@''GNTCONFDGROUP@#$(CONFD_GROUP)#g'; \
1592           echo 's#@''GNTMASTERDGROUP@#$(MASTERD_GROUP)#g'; \
1593           echo 's#@''GNTMONDGROUP@#$(MOND_GROUP)#g'; \
1594           echo 's#@''GNTDAEMONSGROUP@#$(DAEMONS_GROUP)#g'; \
1595           echo 's#@''CUSTOM_ENABLE_CONFD@#$(ENABLE_CONFD)#g'; \
1596           echo 's#@''CUSTOM_ENABLE_MOND@#$(ENABLE_MOND)#g'; \
1597           echo 's#@''MODULES@#$(strip $(lint_python_code))#g'; \
1598           echo 's#@''XEN_CONFIG_DIR@#$(XEN_CONFIG_DIR)#g'; \
1599           echo; \
1600           echo '/^@SHELL_ENV_INIT@$$/ {'; \
1601           echo '  r $(SHELL_ENV_INIT)'; \
1602           echo '  d'; \
1603           echo '}'; \
1604         } > $@
1605
1606 # Using deferred evaluation
1607 daemons/ganeti-%: MODULE = ganeti.server.$(patsubst ganeti-%,%,$(notdir $@))
1608 daemons/ganeti-watcher: MODULE = ganeti.watcher
1609 scripts/%: MODULE = ganeti.client.$(subst -,_,$(notdir $@))
1610 tools/burnin: MODULE = ganeti.tools.burnin
1611 tools/ensure-dirs: MODULE = ganeti.tools.ensure_dirs
1612 tools/node-daemon-setup: MODULE = ganeti.tools.node_daemon_setup
1613 tools/prepare-node-join: MODULE = ganeti.tools.prepare_node_join
1614 tools/node-cleanup: MODULE = ganeti.tools.node_cleanup
1615 $(HS_BUILT_TEST_HELPERS): TESTROLE = $(patsubst test/hs/%,%,$@)
1616
1617 $(PYTHON_BOOTSTRAP): Makefile | stamp-directories
1618         test -n "$(MODULE)" || { echo Missing module; exit 1; }
1619         set -e; \
1620         { echo '#!/usr/bin/python'; \
1621           echo '# This file is automatically generated, do not edit!'; \
1622           echo "# Edit $(MODULE) instead."; \
1623           echo; \
1624           echo '"""Bootstrap script for L{$(MODULE)}"""'; \
1625           echo; \
1626           echo '# pylint: disable=C0103'; \
1627           echo '# C0103: Invalid name'; \
1628           echo; \
1629           echo 'import sys'; \
1630           echo 'import $(MODULE) as main'; \
1631           echo; \
1632           echo '# Temporarily alias commands until bash completion'; \
1633           echo '# generator is changed'; \
1634           echo 'if hasattr(main, "commands"):'; \
1635           echo '  commands = main.commands # pylint: disable=E1101'; \
1636           echo 'if hasattr(main, "aliases"):'; \
1637           echo '  aliases = main.aliases # pylint: disable=E1101'; \
1638           echo; \
1639           echo 'if __name__ == "__main__":'; \
1640           echo '  sys.exit(main.Main())'; \
1641         } > $@
1642         chmod u+x $@
1643
1644 $(HS_BUILT_TEST_HELPERS): Makefile
1645         @test -n "$(TESTROLE)" || { echo Missing TESTROLE; exit 1; }
1646         set -e; \
1647         { echo '#!/bin/sh'; \
1648           echo '# This file is automatically generated, do not edit!'; \
1649           echo "# Edit Makefile.am instead."; \
1650           echo; \
1651           echo "HTOOLS=$(TESTROLE) exec ./test/hs/hpc-htools \"\$$@\""; \
1652         } > $@
1653         chmod u+x $@
1654
1655 stamp-directories: Makefile
1656         $(MAKE) $(AM_MAKEFLAGS) ganeti
1657         @mkdir_p@ $(DIRS) $(BUILDTIME_DIR_AUTOCREATE)
1658         touch $@
1659
1660 # We need to create symlinks because "make distcheck" will not install Python
1661 # files when building.
1662 stamp-srclinks: Makefile | stamp-directories
1663         set -e; \
1664         for i in $(srclink_files); do \
1665           if test ! -f $$i -a -f $(abs_top_srcdir)/$$i; then \
1666             $(LN_S) $(abs_top_srcdir)/$$i $$i; \
1667           fi; \
1668         done
1669         touch $@
1670
1671 .PHONY: ganeti
1672 ganeti:
1673         cd $(top_builddir) && test -h "$@" || { rm -f $@ && $(LN_S) lib $@; }
1674
1675 .PHONY: check-dirs
1676 check-dirs: $(GENERATED_FILES)
1677         @set -e; \
1678         find . -type d \( -name . -o -name .git -prune -o -print \) | { \
1679           error=; \
1680           while read dir; do \
1681             case "$$dir" in \
1682               $(strip $(patsubst %,(./%) ;;,$(DIRCHECK_EXCLUDE) $(DIRS))) \
1683               *) error=1; echo "Directory $$dir not listed in Makefile" >&2 ;; \
1684             esac; \
1685           done; \
1686           for dir in $(DIRS); do \
1687             if ! test -d "$$dir"; then \
1688               echo "Directory $$dir listed in DIRS does not exist" >&2; \
1689               error=1; \
1690             fi \
1691           done; \
1692           test -z "$$error"; \
1693         }
1694
1695 .PHONY: check-local
1696 check-local: check-dirs $(GENERATED_FILES)
1697         $(CHECK_PYTHON_CODE) $(check_python_code)
1698         PYTHONPATH=. $(CHECK_HEADER) $(check_python_code)
1699         $(CHECK_VERSION) $(VERSION) $(top_srcdir)/NEWS
1700         RELEASE=$(PACKAGE_VERSION) $(CHECK_NEWS) < $(top_srcdir)/NEWS
1701         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(CHECK_IMPORTS) . $(standalone_python_modules)
1702         @expver=$(VERSION_MAJOR).$(VERSION_MINOR); \
1703         error= ; \
1704         if test "`head -n 1 $(top_srcdir)/README`" != "Ganeti $$expver"; then \
1705           echo "Incorrect version in README, expected $$expver" >&2; \
1706           error=1; \
1707         fi; \
1708         for file in doc/iallocator.rst doc/hooks.rst doc/virtual-cluster.rst \
1709             doc/security.rst; do \
1710           if test "`sed -ne '4 p' $(top_srcdir)/$$file`" != \
1711             "Documents Ganeti version $$expver"; then \
1712             echo "Incorrect version in $$file, expected $$expver" >&2; \
1713             error=1; \
1714           fi; \
1715         done; \
1716         if ! test -f $(top_srcdir)/doc/design-$$expver.rst; then \
1717           echo "File $(top_srcdir)/doc/design-$$expver.rst not found" >&2; \
1718           error=1; \
1719         fi; \
1720         if test "`sed -ne '5 p' $(top_srcdir)/doc/design-draft.rst`" != \
1721           ".. Last updated for Ganeti $$expver"; then \
1722           echo "doc/design-draft.rst was not updated for version $$expver" >&2; \
1723           error=1; \
1724         fi; \
1725         for file in configure.ac $(HS_LIBTEST_SRCS) $(HS_PROG_SRCS); do \
1726           if test $$(wc --max-line-length < $(top_srcdir)/$$file) -gt 80; then \
1727             echo "Longest line in $$file is longer than 80 characters" >&2; \
1728             error=1; \
1729           fi; \
1730         done; \
1731         test -z "$$error"
1732
1733 .PHONY: hs-tests
1734 hs-tests: test/hs/htest | $(BUILT_PYTHON_SOURCES)
1735         @rm -f htest.tix
1736         ./test/hs/htest
1737
1738 .PHONY: hs-shell
1739 hs-shell: test/hs/hpc-htools test/hs/hpc-mon-collector $(HS_BUILT_TEST_HELPERS)
1740         @rm -f hpc-htools.tix hpc-mon-collector.tix
1741         HBINARY="./test/hs/hpc-htools" ./test/hs/offline-test.sh
1742
1743 .PHONY: hs-check
1744 hs-check: hs-tests hs-shell
1745
1746 # E111: indentation is not a multiple of four
1747 # E121: continuation line indentation is not a multiple of four
1748 #       (since our indent level is not 4)
1749 # E125: continuation line does not distinguish itself from next logical line
1750 #       (since our indent level is not 4)
1751 # E127: continuation line over-indented for visual indent
1752 #       (since our indent level is not 4)
1753 # note: do NOT add E128 here; it's a valid style error in most cases!
1754 # I've seen real errors, but also some cases were we indent wrongly
1755 # due to line length; try to rework the cases where it is triggered,
1756 # instead of silencing it
1757 # E261: at least two spaces before inline comment
1758 # E501: line too long (80 characters)
1759 PEP8_IGNORE = E111,E121,E125,E127,E261,E501
1760
1761 # For excluding pep8 expects filenames only, not whole paths
1762 PEP8_EXCLUDE = $(subst $(space),$(comma),$(strip $(notdir $(BUILT_PYTHON_SOURCES))))
1763
1764 LINT_TARGETS = pylint pylint-qa
1765 if HAS_PEP8
1766 LINT_TARGETS += pep8
1767 endif
1768 if HAS_HLINT
1769 LINT_TARGETS += hlint
1770 endif
1771
1772 .PHONY: lint
1773 lint: $(LINT_TARGETS)
1774
1775 .PHONY: pylint
1776 pylint: $(GENERATED_FILES)
1777         @test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
1778         $(PYLINT) $(LINT_OPTS) $(lint_python_code)
1779
1780 .PHONY: pylint-qa
1781 pylint-qa: $(GENERATED_FILES)
1782         @test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
1783         cd $(top_srcdir)/qa && \
1784           PYTHONPATH=$(abs_top_srcdir) $(PYLINT) $(LINT_OPTS) \
1785           --rcfile  ../pylintrc $(patsubst qa/%.py,%,$(qa_scripts))
1786
1787 .PHONY: pep8
1788 pep8: $(GENERATED_FILES)
1789         @test -n "$(PEP8)" || { echo 'pep8' not found during configure; exit 1; }
1790         $(PEP8) --ignore='$(PEP8_IGNORE)' --exclude='$(PEP8_EXCLUDE)' \
1791           --repeat $(pep8_python_code)
1792
1793 # FIXME: remove ignore "Use void" when GHC 6.x is deprecated
1794 HLINT_EXCLUDES = src/Ganeti/THH.hs test/hs/hpc-htools.hs
1795 .PHONY: hlint
1796 hlint: $(HS_BUILT_SRCS) src/lint-hints.hs
1797         @test -n "$(HLINT)" || { echo 'hlint' not found during configure; exit 1; }
1798         @rm -f doc/hs-lint.html
1799         if tty -s; then C="-c"; else C=""; fi; \
1800         $(HLINT) --utf8 --report=doc/hs-lint.html --cross $$C \
1801           --ignore "Use first" \
1802           --ignore "Use &&&" \
1803           --ignore "Use void" \
1804           --ignore "Reduce duplication" \
1805           --hint src/lint-hints \
1806           $(filter-out $(HLINT_EXCLUDES),$(HS_LIBTEST_SRCS) $(HS_PROG_SRCS))
1807         @if [ ! -f doc/hs-lint.html ]; then \
1808           echo "All good" > doc/hs-lint.html; \
1809         fi
1810
1811 # a dist hook rule for updating the vcs-version file; this is
1812 # hardcoded due to where it needs to build the file...
1813 dist-hook:
1814         $(MAKE) $(AM_MAKEFLAGS) regen-vcs-version
1815         rm -f $(top_distdir)/vcs-version
1816         cp -p $(srcdir)/vcs-version $(top_distdir)
1817
1818 # a distcheck hook rule for catching revision control directories
1819 distcheck-hook:
1820         if find $(top_distdir) -name .svn -or -name .git | grep .; then \
1821           echo "Found revision control files in final archive." 1>&2; \
1822           exit 1; \
1823         fi
1824         if find $(top_distdir) -name '*.py[co]' | grep .; then \
1825           echo "Found Python byte code in final archive." 1>&2; \
1826           exit 1; \
1827         fi
1828         if find $(top_distdir) -name '*~' | grep .; then \
1829           echo "Found backup files in final archive." 1>&2; \
1830           exit 1; \
1831         fi
1832 # Empty files or directories should not be distributed. They can cause
1833 # unnecessary warnings for packagers. Directories used by automake during
1834 # distcheck must be excluded.
1835         if find $(top_distdir) -empty -and -not \( \
1836             -path $(top_distdir)/_build -or \
1837             -path $(top_distdir)/_inst \) | grep .; then \
1838           echo "Found empty files or directories in final archive." 1>&2; \
1839           exit 1; \
1840         fi
1841         if test -e $(top_distdir)/doc/man-html; then \
1842           echo "Found documentation including man pages in final archive" >&2; \
1843           exit 1; \
1844         fi
1845
1846 # Backwards compatible distcheck-release target
1847 distcheck-release: distcheck
1848
1849 distrebuildcheck: dist
1850         set -e; \
1851         builddir=$$(mktemp -d $(abs_srcdir)/distrebuildcheck.XXXXXXX); \
1852         trap "echo Removing $$builddir; cd $(abs_srcdir); rm -rf $$builddir" EXIT; \
1853         cd $$builddir; \
1854         tar xzf $(abs_srcdir)/$(distdir).tar.gz; \
1855         cd $(distdir); \
1856         ./configure; \
1857         $(MAKE) maintainer-clean; \
1858         cp $(abs_srcdir)/vcs-version .; \
1859         ./configure; \
1860         $(MAKE) $(AM_MAKEFLAGS)
1861
1862 dist-release: dist
1863         set -e; \
1864         for i in $(DIST_ARCHIVES); do \
1865           echo -n "Checking $$i ... "; \
1866           autotools/check-tar < $$i; \
1867           echo OK; \
1868         done
1869
1870 install-exec-local:
1871         @mkdir_p@ "$(DESTDIR)${localstatedir}/lib/ganeti" \
1872           "$(DESTDIR)${localstatedir}/log/ganeti" \
1873           "$(DESTDIR)${localstatedir}/run/ganeti"
1874
1875 .PHONY: apidoc
1876 if WANT_HSAPIDOC
1877 apidoc: py-apidoc hs-apidoc
1878 else
1879 apidoc: py-apidoc
1880 endif
1881
1882 .PHONY: py-apidoc
1883 py-apidoc: epydoc.conf $(RUN_IN_TEMPDIR) $(GENERATED_FILES)
1884         env - PATH="$$PATH" PYTHONPATH="$$PYTHONPATH" \
1885         $(RUN_IN_TEMPDIR) epydoc -v \
1886           --conf $(CURDIR)/epydoc.conf \
1887           --output $(CURDIR)/$(APIDOC_PY_DIR)
1888
1889 .PHONY: hs-apidoc
1890 hs-apidoc: $(APIDOC_HS_DIR)/index.html
1891
1892 $(APIDOC_HS_DIR)/index.html: $(HS_LIBTESTBUILT_SRCS) Makefile
1893         @test -n "$(HSCOLOUR)" || \
1894             { echo 'HsColour' not found during configure; exit 1; }
1895         @test -n "$(HADDOCK)" || \
1896             { echo 'haddock' not found during configure; exit 1; }
1897         rm -rf $(APIDOC_HS_DIR)/*
1898         for i in $(ALL_APIDOC_HS_DIRS); do \
1899           @mkdir_p@ $$i; \
1900           $(HSCOLOUR) -print-css > $$i/hscolour.css; \
1901         done
1902         set -e ; \
1903         export LC_ALL=en_US.UTF-8; \
1904         OPTGHC="--optghc=-isrc --optghc=-itest/hs"; \
1905         if [ "$(HS_PARALLEL3)" ]; \
1906         then OPTGHC="$$OPTGHC --optghc=$(HS_PARALLEL3)"; \
1907         fi; \
1908         if [ "$(HS_REGEX_PCRE)" ]; \
1909         then OPTGHC="$$OPTGHC --optghc=$(HS_REGEX_PCRE)"; \
1910         fi; \
1911         for file in $(HS_LIBTESTBUILT_SRCS); do \
1912           f_nosrc=$${file##src/}; \
1913           f_notst=$${f_nosrc##test/hs/}; \
1914           f_html=$${f_notst%%.hs}.html; \
1915           $(HSCOLOUR) -css -anchor $$file > $(APIDOC_HS_DIR)/$$f_html ; \
1916         done ; \
1917         $(HADDOCK) --odir $(APIDOC_HS_DIR) --html --ignore-all-exports -w \
1918           -t ganeti -p src/haddock-prologue \
1919           --source-module="%{MODULE/.//}.html" \
1920           --source-entity="%{MODULE/.//}.html#%{NAME}" \
1921           $$OPTGHC \
1922           $(HS_LIBTESTBUILT_SRCS)
1923
1924 .PHONY: TAGS
1925 TAGS: $(GENERATED_FILES)
1926         rm -f TAGS
1927         $(GHC) -e ":etags" -v0 \
1928           $(filter-out -O -Werror,$(HFLAGS)) \
1929           $(HS_PARALLEL3) $(HS_REGEX_PCRE) \
1930           $(HS_LIBTEST_SRCS)
1931         find . -path './lib/*.py' -o -path './scripts/gnt-*' -o \
1932           -path './daemons/ganeti-*' -o -path './tools/*' -o \
1933           -path './qa/*.py' | \
1934           etags -l python -a -
1935
1936 .PHONY: coverage
1937 if WANT_HTOOLS
1938 coverage: py-coverage hs-coverage
1939 else
1940 coverage: py-coverage
1941 endif
1942
1943 .PHONY: py-coverage
1944 py-coverage: $(GENERATED_FILES) $(python_tests)
1945         @test -n "$(PYCOVERAGE)" || \
1946             { echo 'python-coverage' not found during configure; exit 1; }
1947         set -e; \
1948         COVERAGE=$(PYCOVERAGE) \
1949         COVERAGE_FILE=$(CURDIR)/$(COVERAGE_PY_DIR)/data \
1950         TEXT_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR)/report.txt \
1951         HTML_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR) \
1952         $(PLAIN_TESTS_ENVIRONMENT) \
1953         $(abs_top_srcdir)/autotools/gen-py-coverage \
1954         $(python_tests)
1955
1956 .PHONY: hs-coverage
1957 hs-coverage: $(haskell_tests) test/hs/hpc-htools test/hs/hpc-mon-collector
1958         rm -f *.tix
1959         $(MAKE) $(AM_MAKEFLAGS) hs-check
1960         @mkdir_p@ $(COVERAGE_HS_DIR)
1961         hpc sum --union $(HPCEXCL) \
1962           htest.tix hpc-htools.tix hpc-mon-collector.tix > coverage-hs.tix
1963         hpc markup --destdir=$(COVERAGE_HS_DIR) coverage-hs.tix
1964         hpc report coverage-hs.tix
1965         $(LN_S) -f hpc_index.html $(COVERAGE_HS_DIR)/index.html
1966
1967 # Special "kind-of-QA" target for htools, needs special setup (all
1968 # tools compiled with -fhpc)
1969 .PHONY: live-test
1970 live-test: all
1971         set -e ; \
1972         cd src; \
1973         rm -f .hpc; $(LN_S) ../.hpc .hpc; \
1974         rm -f *.tix *.mix; \
1975         ./live-test.sh; \
1976         hpc sum --union $(HPCEXCL) $(addsuffix .tix,$(HS_PROGS:src/%=%)) \
1977           --output=live-test.tix ; \
1978         @mkdir_p@ ../$(COVERAGE_HS_DIR) ; \
1979         hpc markup --destdir=../$(COVERAGE_HS_DIR) live-test \
1980           --srcdir=.. $(HPCEXCL) ; \
1981         hpc report --srcdir=.. live-test $(HPCEXCL)
1982
1983 commit-check: distcheck lint apidoc
1984
1985 .PHONY: gitignore-check
1986 gitignore-check:
1987         @if [ -n "`git status --short`" ]; then \
1988           echo "Git status is not clean!" 1>&2 ; \
1989           git status --short; \
1990           exit 1; \
1991         fi
1992
1993 # target to rebuild all man pages (both groff and html output)
1994 .PHONY: man
1995 man: $(man_MANS) $(manhtml)
1996
1997 # Target that builds all binaries (including those that are not
1998 # rebuilt except when running the tests)
1999 .PHONY: really-all
2000 really-all: all $(check_SCRIPTS) $(haskell_tests) $(HS_ALL_PROGS)
2001
2002 # we don't need the ancient implicit rules:
2003 %: %,v
2004 %: RCS/%,v
2005 %: RCS/%
2006 %: s.%
2007 %: SCCS/s.%
2008
2009 -include ./Makefile.local
2010
2011 # vim: set noet :